

varying vec4 lmtexcoord;
varying vec4 color;
varying vec3 normalMat;

flat varying vec4 labvalue;

flat varying float emissive;

#if defined ENTITY && defined NO_ENTITY_TAA

/* DRAWBUFFERS:025*/
#else
/* DRAWBUFFERS:02*/

#endif

void main()
{

    vec4 albedo = texture(texture, lmtexcoord.xy, 0);
    albedo.rgb = toLinear(albedo.rgb * color.rgb);

#ifdef ENTITY
#ifdef NAMETAG_FIX

    if (lmtexcoord.r > 0.0 && lmtexcoord.r < 0.02 && lmtexcoord.g > 0.0351 && lmtexcoord.g < 0.0666 && albedo == vec4(0.0, 0.0, 0.0, 1.0))
    {

        // albedo.rgb = vec3(0.5);
        albedo.a = 0.0;
    }
    if (lmtexcoord.r > 0.49 && lmtexcoord.r < 0.51 && lmtexcoord.g > 0.49 && lmtexcoord.g < 0.51 && albedo == vec4(0.0, 0.0, 0.0, 1.0))
    {

        // albedo.rgb = vec3(0.5);
        albedo.a = 0.0;
    }
#endif

#endif
    vec2 lightmap = lmtexcoord.zw;
    vec2 materials1 = vec2(color.a, labvalue.z);
    lightmap.x += emissive;
    albedo.rgb += (emissive * 8 * albedo.rgb * albedo.rgb);
    gl_FragData[0] = albedo;                                                                                        // Albedo
    gl_FragData[1].rgba = vec4(encodeNormal(normalMat), encodeVec2(clamp(lightmap, 0, 1)), encodeVec2(materials1)); // normals
#ifdef ENTITY
#ifdef NO_ENTITY_TAA

    gl_FragData[2].g = 1; // Materials

#endif
#endif
}
