
flat varying vec4 labvalue;

varying vec4 lmtexcoord;
varying vec4 color;
flat varying float emissive;
attribute vec4 mc_midTexCoord;

attribute vec4 mc_Entity;

varying vec3 normalMat;

#define diagonal3(m) vec3((m)[0].x, (m)[1].y, m[2].z)
#define projMAD(m, v) (diagonal3(m) * (v) + (m)[3].xyz)

#include "/lib/vertex/main.glsl"

void main()
{
    // Define Transforms

    lmtexcoord.xyzw = vec4(gl_MultiTexCoord0.xy, gl_MultiTexCoord1.xy * recip);
    color = gl_Color;
    int entityCheck = int(mc_Entity.x);
    labvalue = getMaterialProperties(entityCheck);

    // Emissive Check
    emissive = 0.0;

    if (entityCheck >= 100 && entityCheck <= 355)
        emissive = pow(lmtexcoord.z, 8.0);

    normalMat = gl_Normal;

    vec3 position = (mat3(gl_ModelViewMatrix) * gl_Vertex.xyz) + gl_ModelViewMatrix[3].xyz;

#ifdef LEAVES

    bool Flower = isFlower(entityCheck, (gl_MultiTexCoord0.t < mc_midTexCoord.t));
    bool Leaves = isLeaves(entityCheck, (abs(position.z) < 64.0 && gl_MultiTexCoord1.y > 100.0));
    vec4 temp = gl_Vertex;
    vec4 temp2 = gl_MultiTexCoord1;
    if (Flower || Leaves)
    {
        position = computeWaveOffset(position, cameraPosition, temp, temp2, gbufferModelView);
    }

#endif

    // Final Position Calculation
#if defined ENTITY && defined NO_ENTITY_TAA
    gl_Position = toClipSpace4(position);
#else
    gl_Position = taaFunc(toClipSpace4(position));
#endif
}
