

flat varying vec3 ambientUp;
flat varying vec3 ambientDown;
flat varying vec3 ambientLeft;
flat varying vec3 ambientRight;
flat varying vec3 ambientB;
flat varying vec3 ambientF;
flat varying float ambientA;
flat varying vec4 sunColor;
varying vec2 texcoord;

#include "/lib/sky_function.glsl"
//////////////////////////////VOID MAIN//////////////////////////////
//////////////////////////////VOID MAIN//////////////////////////////
//////////////////////////////VOID MAIN//////////////////////////////
//////////////////////////////VOID MAIN//////////////////////////////
//////////////////////////////VOID MAIN//////////////////////////////

vec3 applyDirectionalWeighting(vec3 center, vec3 left, vec3 right, vec3 up, vec3 down)
{
    float weightCenter = 0.4;     // Highest weight for the center
    float weightSides = 0.15;     // Equal, lower weight for left and right
    float weightVerticals = 0.15; // Equal, lower weight for up and down

    // Apply weights
    // return center;
    return center * weightCenter + (left + right) * weightSides + (up + down) * weightVerticals;
}

void calculateLighting1(
    out vec3 ambientUp,
    out vec3 ambientLeft,
    out vec3 ambientRight,
    out vec3 ambientB,
    out vec3 ambientF,
    out vec3 ambientDown,
    out float ambientA,
    out vec4 sunColor)
{
    float sunVis = clamp(sunElevation, 0.0, 0.05) / 0.05 * clamp(sunElevation, 0.0, 0.05) / 0.05;
    sunColor = vec4(sunLight, sunVis);

    // Up
    vec3 up = vec3(0.0, 1.0, 0.0);
    vec3 down = vec3(0.0, 1.0, 0.0);

    // Left, sorted by tilt
    vec3 left = vec3(-1.0, 0.0, 0.0);
    vec3 left_50_up = vec3(-1.0, 0.5, 0.0);

    // Forward, sorted by tilt
    vec3 forward = vec3(0.0, 0.0, 1.0);
    vec3 forward_50_up = vec3(0.0, 0.5, 1.0);

    // Right, sorted by tilt
    vec3 right = vec3(1.0, 0.0, 0.0);
    vec3 right_50_up = vec3(1.0, 0.5, 0.0);

    // Backward, sorted by tilt
    vec3 backward = vec3(0.0, 0.0, -1.0);
    vec3 backward_50_up = vec3(0.0, 0.5, -1.0);

    // vec3 upS = skyFromTex2(up, colortex6).rgb;
    vec3 upS = skyFromTex2(up, colortex6).rgb;

    vec3 downS = skyFromTex2(down, colortex6).rgb;

    vec3 leftS0 = skyFromTex2(left, colortex6).rgb;
    vec3 leftS = skyFromTex2(left_50_up, colortex6).rgb;

    vec3 rightS0 = skyFromTex2(right, colortex6).rgb;
    vec3 rightS = skyFromTex2(right_50_up, colortex6).rgb;

    vec3 frontS0 = skyFromTex2(forward, colortex6).rgb;
    vec3 frontS = skyFromTex2(forward_50_up, colortex6).rgb;

    vec3 backS0 = skyFromTex2(backward, colortex6).rgb;
    vec3 backS = skyFromTex2(backward_50_up, colortex6).rgb;

    ambientUp = applyDirectionalWeighting(upS, leftS, rightS, frontS, backS);
    ambientDown = applyDirectionalWeighting(downS, leftS, rightS, frontS, backS);

    ambientLeft = applyDirectionalWeighting(leftS, upS, leftS0, frontS, backS);

    ambientRight = applyDirectionalWeighting(rightS, upS, rightS0, frontS, backS);

    ambientF = applyDirectionalWeighting(frontS, upS, frontS0, leftS, rightS);

    ambientB = applyDirectionalWeighting(backS, upS, backS0, leftS, rightS);

    ambientA = luma((ambientUp + ambientLeft + ambientRight + ambientB + ambientF + ambientDown) / 6);
}

vec2 SinCos(float x)
{
    return vec2(sin(x), cos(x));
}

vec3 GenerateUnitVector(vec2 xy)
{
    xy.x *= radians(360.0);
    xy.y = xy.y * 2.0 - 1.0;
    return vec3(SinCos(xy.x) * sqrt(1.0 - xy.y * xy.y), xy.y);
}
void calculateLighting2(
    out vec3 ambientUp,
    out vec3 ambientLeft,
    out vec3 ambientRight,
    out vec3 ambientB,
    out vec3 ambientF,
    out vec3 ambientDown,
    out float ambientA,
    out vec4 sunColor)
{
    float sunVis = clamp(sunElevation, 0.0, 0.05) / 0.05 * clamp(sunElevation, 0.0, 0.05) / 0.05;
    sunColor = vec4(sunLight, sunVis);

    // const ivec2 samples = ivec2(64, 32);
    const ivec2 samples = ivec2(32, 16);

    ambientRight = vec3(0.0);
    ambientUp = vec3(0.0);
    ambientF = vec3(0.0);

    ambientLeft = vec3(0.0);
    ambientDown = vec3(0.0);
    ambientB = vec3(0.0);

    for (int x = 0; x < samples.x; ++x)
    {
        for (int y = 0; y < samples.y; ++y)
        {
            vec3 dir = GenerateUnitVector((vec2(x, y) + 0.5) / samples);
            if (dir.y < 0.0)
            {
                dir.y = -dir.y;
            }

            vec3 skySample = skyFromTex2(dir, colortex6).rgb;

            ambientRight += skySample * clamp(dir.x, 0.0, 1.0);
            ambientUp += skySample * clamp(dir.y, 0.0, 1.0);
            ambientF += skySample * clamp(dir.z, 0.0, 1.0);

            ambientLeft += skySample * clamp(-dir.x, 0.0, 1.0);
            ambientB += skySample * clamp(-dir.z, 0.0, 1.0);
        }
    }

    const float sampleWeight = 2.0 / (samples.x * samples.y);
    ambientRight *= sampleWeight;
    ambientUp *= sampleWeight;
    ambientF *= sampleWeight;

    ambientLeft *= sampleWeight;
    ambientB *= sampleWeight;

    // super simple fake skylight bounce
    const float fakeBounceAlbedo = 0.5;
    ambientRight += ambientUp * fakeBounceAlbedo * 0.5;
    ambientF += ambientUp * fakeBounceAlbedo * 0.5;

    ambientLeft += ambientUp * fakeBounceAlbedo * 0.5;
    ambientDown += ambientUp * fakeBounceAlbedo;
    ambientB += ambientUp * fakeBounceAlbedo * 0.5;

    float lightDir = float(sunVis >= 1e-5) * 2.0 - 1.0;
#ifndef OVERWORLD
    vec3 sunLight = ambientUp * 512.0;
#endif

    // Fake bounced sunlight
    vec3 bouncedSun = sunLight * 0.001;
    ambientUp += bouncedSun * clamp(-lightDir * sunVec.y + 3., 0., 4.0);
    ambientLeft += bouncedSun * clamp(lightDir * sunVec.x + 3., 0.0, 4.);
    ambientRight += bouncedSun * clamp(-lightDir * sunVec.x + 3., 0.0, 4.);
    ambientB += bouncedSun * clamp(-lightDir * sunVec.z + 3., 0.0, 4.);
    ambientF += bouncedSun * clamp(lightDir * sunVec.z + 3., 0.0, 4.);
    ambientDown += bouncedSun * clamp(lightDir * sunVec.y + 3., 0.0, 4.) * 0.7;

    ambientA = luma((ambientUp + ambientLeft + ambientRight + ambientB + ambientF + ambientDown) / 6);
}

void main()
{

    texcoord = gl_MultiTexCoord0.xy;

    calculateLighting2(ambientUp, ambientLeft, ambientRight, ambientB, ambientF, ambientDown, ambientA, sunColor);

    gl_Position = ftransform();
}
