#version 120
#define SHADOWPROG
#extension GL_ARB_explicit_attrib_location : enable
#extension GL_ARB_shader_image_load_store : enable

#include "/includes/main.glsl"

#include "/lib/vertex/main.glsl"
varying vec4 color;
varying vec2 lmtexcoord;
#if defined DISTANT_HORIZONS && !defined SHADOW_DEBUG
varying vec3 viewVector;
#endif
attribute vec4 mc_Entity;
attribute vec4 mc_midTexCoord;

#ifdef LPV_ENABLED
#define SHADOW_MAP_BIAS 0.5
attribute vec4 at_midBlock;
#include "/lib/lpv/blocks.glsl"
#include "/lib/lpv/entities.glsl"


#include "/lib/lpv/voxel_common.glsl"
#include "/lib/lpv/voxel_write.glsl"
#endif

vec3 mul3(const in mat4 matrix, const in vec3 vector)
{
    return mat3(matrix) * vector + matrix[3].xyz;
}
// varying vec3 normal;

void main()
{
#ifdef LPV_ENABLED
    PopulateShadowVoxel(mat3(shadowModelViewInverse) * (mat3(gl_ModelViewMatrix) * vec3(gl_Vertex) + gl_ModelViewMatrix[3].xyz) + shadowModelViewInverse[3].xyz);
#endif

    color = gl_Color;

    vec4 position = gl_ModelViewProjectionMatrix * gl_Vertex;

#ifdef SHADOW_WAVE
    int entityCheck = int(mc_Entity.x);

    bool Flower = isFlower(entityCheck, (gl_MultiTexCoord0.t < mc_midTexCoord.t));
    bool Leaves = isLeaves(entityCheck, (abs(position.z) < 128.0 && gl_MultiTexCoord1.y > 100.0));
    vec4 temp = gl_Vertex;
    vec4 temp2 = gl_MultiTexCoord1;
    if (Flower || Leaves)
    {

        position.xyz = computeWaveOffsetShadow(position.xyz, cameraPosition, temp, temp2, gbufferModelView);
        position.xyz = toClipSpace3_shadow(position.xyz).xyz;
    }
#endif

    position.z *= 0.1666666666666667; // 1/6
   // position.z += 0.0005;
    vec2 shadowDistortion = calcShadowDistortion(position.xyz);
    position.xy = shadowDistortion;

    vec3 shadowViewPos = mul3(gl_ModelViewMatrix, gl_Vertex.xyz);
#if defined DISTANT_HORIZONS && !defined SHADOW_DEBUG

    viewVector = mul3(shadowModelViewInverse, shadowViewPos);
#endif
    lmtexcoord.xy = gl_MultiTexCoord0.xy;
    // normal = normalize(gl_NormalMatrix * gl_Normal);

    gl_Position = position;
}
